use argh::FromArgs;

#[derive(FromArgs)]
/// Control your herd
pub struct SheepctlArgs {
    #[argh(subcommand)]
    pub command: SheepctlCommand,
}

#[derive(FromArgs, PartialEq, Debug)]
#[argh(subcommand)]
pub enum SheepctlCommand {
    Login(LoginCommand),
    Device(DeviceCommand),
}

#[derive(FromArgs, PartialEq, Debug)]
/// Login to a homeserver
#[argh(subcommand, name = "login")]
pub struct LoginCommand {
    #[argh(positional)]
    /// homeserver
    pub home: String,

    #[argh(positional)]
    /// username
    pub username: String,
}

#[derive(FromArgs, PartialEq, Debug)]
#[argh(subcommand, name = "device")]
/// Commands for devices
pub struct DeviceCommand {
    #[argh(subcommand)]
    pub command: DeviceCommands,
}

#[derive(FromArgs, PartialEq, Debug)]
#[argh(subcommand)]
pub enum DeviceCommands {
    List(ListDevicesCommand),
}

#[derive(FromArgs, PartialEq, Debug)]
/// List devices
#[argh(subcommand, name = "ls")]
pub struct ListDevicesCommand {
    #[argh(switch)]
    /// only show online devices
    pub online: bool,
}
